diff --git a/package/network/utils/xtables-addons/Makefile b/package/network/utils/xtables-addons/Makefile
index da8058e..053840f 100644
--- a/package/network/utils/xtables-addons/Makefile
+++ b/package/network/utils/xtables-addons/Makefile
@@ -9,9 +9,9 @@ include $(TOPDIR)/rules.mk
 include $(INCLUDE_DIR)/kernel.mk
 
 PKG_NAME:=xtables-addons
-PKG_VERSION:=2.10
+PKG_VERSION:=2.11
 PKG_RELEASE:=1
-PKG_MD5SUM:=727bf0dd4a3d9c65724267bd0d5d80b0
+PKG_MD5SUM:=9f3123295db81a9d1bc08dabf075d0d6
 
 PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.xz
 PKG_SOURCE_URL:=@SF/xtables-addons
@@ -39,7 +39,6 @@ endef
 
 CONFIGURE_ARGS+= \
 	--with-kbuild="$(LINUX_DIR)" \
-	--with-xtables="$(STAGING_DIR)/usr" \
 	--with-xtlibdir="/usr/lib/iptables" \
 
 define Build/Compile
diff --git a/package/network/utils/xtables-addons/patches/001-build-fix-configure-compatiblity-with-POSIX-shells.patch b/package/network/utils/xtables-addons/patches/001-build-fix-configure-compatiblity-with-POSIX-shells.patch
deleted file mode 100644
index e0b11b5..0000000
--- a/package/network/utils/xtables-addons/patches/001-build-fix-configure-compatiblity-with-POSIX-shells.patch
+++ /dev/null
@@ -1,51 +0,0 @@
-From f07a0a5cb8b3c5e1aee8b30c7fa21ccfbf24a95a Mon Sep 17 00:00:00 2001
-Message-Id: <f07a0a5cb8b3c5e1aee8b30c7fa21ccfbf24a95a.1459880505.git.mschiffer@universe-factory.net>
-From: Matthias Schiffer <mschiffer@universe-factory.net>
-Date: Fri, 1 Apr 2016 22:24:00 +0200
-Subject: [PATCH] build: fix configure compatiblity with POSIX shells
-
-The kernel version detection code uses some bashisms, which makes the build
-fail on Debian systems where /bin/sh links to dash. Replace with POSIX-
-conforming commands at the cost of requiring awk.
----
- configure.ac | 24 +++++++++---------------
- 1 file changed, 9 insertions(+), 15 deletions(-)
-
-diff --git a/configure.ac b/configure.ac
-index 82a1355..5a5ea57 100644
---- a/configure.ac
-+++ b/configure.ac
-@@ -44,21 +44,15 @@ regular_CFLAGS="-Wall -Waggregate-return -Wmissing-declarations \
- 
- if test -n "$kbuilddir"; then
- 	AC_MSG_CHECKING([kernel version that we will build against])
--	krel="$(make -sC "$kbuilddir" M=$PWD kernelrelease)";
--	kmajor="${krel%%[[^0-9]]*}";
--	kmajor="$(($kmajor+0))";
--	krel="${krel:${#kmajor}}";
--	krel="${krel#.}";
--	kminor="${krel%%[[^0-9]]*}";
--	kminor="$(($kminor+0))";
--	krel="${krel:${#kminor}}";
--	krel="${krel#.}";
--	kmicro="${krel%%[[^0-9]]*}";
--	kmicro="$(($kmicro+0))";
--	krel="${krel:${#kmicro}}";
--	krel="${krel#.}";
--	kstable="${krel%%[[^0-9]]*}";
--	kstable="$(($kstable+0))";
-+	krel="$(make -sC "$kbuilddir" M=$PWD kernelrelease | $AWK -v 'FS=[[^0-9.]]' '{print $1; exit}')";
-+	save_IFS=$IFS;
-+	IFS='.';
-+	set x $krel;
-+	IFS=$save_IFS;
-+	kmajor="$(($2+0))";
-+	kminor="$(($3+0))";
-+	kmicro="$(($4+0))";
-+	kstable="$(($5+0))";
- 	if test -z "$kmajor" -o -z "$kminor" -o -z "$kmicro"; then
- 		echo "WARNING: Version detection did not succeed. Continue at own luck.";
- 	else
--- 
-2.8.0
-
diff --git a/package/network/utils/xtables-addons/patches/002-fix-kernel-version-detection.patch b/package/network/utils/xtables-addons/patches/002-fix-kernel-version-detection.patch
index 6a7a099..775ccf6 100644
--- a/package/network/utils/xtables-addons/patches/002-fix-kernel-version-detection.patch
+++ b/package/network/utils/xtables-addons/patches/002-fix-kernel-version-detection.patch
@@ -1,11 +1,11 @@
 --- a/configure.ac
 +++ b/configure.ac
-@@ -44,7 +44,7 @@ regular_CFLAGS="-Wall -Waggregate-return -Wmissing-declarations \
+@@ -44,7 +44,7 @@ regular_CFLAGS="-Wall -Waggregate-return
  
  if test -n "$kbuilddir"; then
  	AC_MSG_CHECKING([kernel version that we will build against])
--	krel="$(make -sC "$kbuilddir" M=$PWD kernelrelease | $AWK -v 'FS=[[^0-9.]]' '{print $1; exit}')";
-+	krel="$(make -sC "$kbuilddir" M=$PWD kernelversion | $AWK -v 'FS=[[^0-9.]]' '{print $1; exit}')";
- 	save_IFS=$IFS;
- 	IFS='.';
- 	set x $krel;
+-	krel="$(make -sC "$kbuilddir" M=$PWD kernelrelease | $AWK -v 'FS=[[^0-9.]]' '{print $1; exit}')"
++	krel="$(make -sC "$kbuilddir" M=$PWD kernelversion | $AWK -v 'FS=[[^0-9.]]' '{print $1; exit}')"
+ 	save_IFS="$IFS"
+ 	IFS='.'
+ 	set x $krel